GETGROUPLIST(3) | Library Functions Manual | GETGROUPLIST(3)

# NAME

`getgrouplist`, `getgroupmembership` —
calculate group access list

# LIBRARY

Standard C Library (libc, -lc)

# SYNOPSIS

`#include <unistd.h>`

int
`getgrouplist`(const char *name, gid_t basegid, gid_t *groups, int *ngroups);

int
`getgroupmembership`(const char *name, gid_t basegid, gid_t *groups, int maxgrp, int *ngroups);

# DESCRIPTION

The `getgrouplist`() and `getgroupmembership`() functions read through the group database and calculate the group access list for the user specified in name. The basegid is automatically included in the groups list. Typically this value is given as the group number from the password database.

The resulting group list is returned in the integer array pointed to by groups.

For `getgrouplist`(), the caller specifies the size of the groups array in the integer pointed to by ngroups.

For `getgroupmembership`(), the caller specifies the size of the groups array in maxgrp.

The actual number of groups found is returned in ngroups.

Duplicate group ids will be suppressed from the result.

# RETURN VALUES

The `getgrouplist`() and `getgroupmembership`() functions return 0 if successful, and return -1 if the size of the group list is too small to hold all the user's groups. In the latter case, the groups array will be filled with as many groups as will fit and ngroups will contain the total number of groups found.

# FILES

/etc/group
  group membership list

# SEE ALSO

setgroups(2), initgroups(3), group(5)

# HISTORY

The `getgrouplist`() function first appeared in 4.4BSD. The `getgroupmembership`() function first appeared in NetBSD 3.0 to address an API deficiency in `getgrouplist`().

# BUGS

The `getgrouplist`() function uses the routines based on getgrent(3). If the invoking program uses any of these routines, the group structure will be overwritten in the call to `getgrouplist`().

January 6, 2005 | NetBSD 9.1